#!/usr/bin/python
# coding=utf8

from __future__ import division

### Audio-Modul

import pyaudio
from microlistener import MicroListener

##############

# Graphik und Berechnungen


from plotanzeige import Anzeige,plt  

##  Anzeige ist die dort definierte Klasse,
##  plt ist das dort bereits importierte pyplot

import numpy as np

###  Zeit

import time

###########################

### GLOBALE VARIABLEN

CHANNELS=1
RATE=44100
DAUER=1
ANZAHL=DAUER*RATE # ANZAHL der Frames,
CHUNK=2**11

# globale Variablen, schlechter Programmierstil, hier aber ganz
# praktisch: Nach Aufnahme oder Lesen werden diese Variablen 
# entsprechend gesetzt.

########################################


### Anzeige setup, hier wird das 'idle'-Event (=nichts weiter
### zu tun) mit dem Zeichnen des momentanen Plots verbunden


anzeige=Anzeige(CHUNK,RATE)

### Audio setup ###########################################

###  Hier wird ein 'Audio-Stream' gestartet, der immer, wenn
### CHUNK  Frames aus dem Mikrophon gelesen wurden, die Funktion
### micro_callback aufruft, die diese Daten dann in den Plot
### 'anzeige' schreibt. Stattdessen könnte man die Daten auch 
### erste bearbeiten und irgendwoanders hin schreiben.
### Dieser Audiostream läuft unabhängig vom weiteren Programm.
### Die Daten in anzeige.kurve sind also stets aktuell.
### Ums Anzeigen kümmert sich dann 'gtk'.

##############################################################


def micro_callback(in_data, frame_count, time_info, status):
	'''callback Funktion: wird vom PyAudio-Objekt aufgerufen,
	wenn CHUNK Frames von der Soundkarte (Mikrophon) gelesen wurden'''
	y=np.array(np.fromstring(in_data,dtype=np.short),dtype=np.float)
	if CHANNELS==2:
		y=y.reshape((y.shape[0]//2,2))
	else:
		y=y.reshape((y.shape[0],1))
	anzeige.update(y[:,0])
	return (in_data, pyaudio.paContinue)

listener=MicroListener(RATE,CHANNELS,CHUNK,micro_callback)

#################################################

###  durch diesen Aufruf wird nicht nur angezeigt, was
### anzuzeigen ist, sondern auch die Ereignis-Verarbeitung
### von gtk gestartet, eine Endlosschleife, die beim Ausbleiben
### sonstiger Ereignisse den Graphen mit den aktuellen Daten
### neu zeichnet (siehe oben, idle_add(...) )
### Die Schleife wird erst verlassen, wenn wir das Graphik-Fenster
### schließen.

plt.show()
